<?php
/*
 * Plugin Name: CoolIris-Piclens
 * Version: 0.3.2
 * Description: Cooliris/Piclens activation
 * Plugin URI: http://fr.piwigo.org/ext/extension_view.php?eid=234
 * Author: Tiico
 * Author URI: 
 * */
/********* Fichier generate_rss.php  *********/

$debug = false;

 
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

include (PICLENS_INC_PATH.'config_extendeddesc.inc.php');	// Parametres pour extended description.

// recuperation du parametre pour le mode no recursif (forage de la non recursivite)
if (isset($_GET['norecurs'])) 
{
	$obj->my_config['piclens_recursive'] = false;
}


// extensions video
$py_addext = array("gvideo", "dm", "ytube", "wideo", "vimeo", "flv");
$video_ext_piclens = array("flv");

// Vrification prsence et activation plugin SecureImages ET si actif, vrification d'activation de compatibilit
$plugins_SecureImage_only = (get_db_plugins('active','secureImages') ? true : false );
$plugins_SecureImage = ($plugins_SecureImage_only && ($obj->my_config['piclens_secureimage']) ? true : false );
// Verification presence et activation plugin ExtendedDescription 
$plugins_ExtendedDesc = (get_db_plugins('active','ExtendedDescription') && ($obj->my_config['piclens_extendeddesc']) ? true : false );

// Vrification d'activation du plugin (page administration) OU activation de piclensWall
if ($obj->my_config['piclens_active'] OR $obj->my_config['piclens_wall'] OR (!$obj->my_config['piclens_wall'] AND get_db_plugins('active','PWG_Stuffs')))
{
	//-------------------------------------------------------------- initialization

	// Mode des miniatures et des images normales dans piclens (avec et sans plugin secureimage)
	$thumb_secure = array('', '&amp;thumb=1', '');	// correspondant a 1-->'miniature' et 2-->'normal'
	$normal_secure = array('', '&amp;thumb=1', '', '&amp;highdef=1');	// correspondant a 1-->'miniature' et 2-->'normal' et 3 --> High
	$order_list = array('', $conf['order_by_inside_category'], 'ORDER BY date_creation', 'ORDER BY date_available', 'ORDER BY average_rate', 'ORDER BY hit', 'ORDER BY file', 'ORDER BY id', 'ORDER BY RAND()', 'ORDER BY category_id');	
	$order_sort = array('', '', ' ASC', ' DESC');

	// Extensions a prendre en compte
	$tn_ext_is_null = false;
	$type_ext = $obj->my_config['included_file_types'];
	foreach($type_ext as $i => $value)
	{
		if ($value == '!NULL!')	$tn_ext_is_null = true;
		$type_ext[$i] = '"'.($value == '!NULL!' ? 'NULL' : $value).'"';
	}

	// Categories a prendre en compte pour le mur
	$piclenswall_cat = (isset($obj->my_config['piclens_wall_categories']) ? $obj->my_config['piclens_wall_categories'] : array());

	// Seulement sur une page type 'categorie'
	if (isset($page['section']))
	{
		$cat = array();
		$pictures = array();

		$forbidden = get_sql_condition_FandF(
			  array
				(
				  'forbidden_categories' => 'category_id',
				  'visible_categories' => 'category_id',
				  'visible_images' => 'id'
				),
			  'AND'
		  );
		
		// Images recentes
		if (($page['section']) == 'recent_pics')
		{
		    if ( !isset($page['super_order_by']) )
		    {
		      $conf['order_by'] = str_replace(
		        'ORDER BY ',
		        'ORDER BY date_available DESC,',
		        $conf['order_by']
		        );
		    }			
			// $cat need to bo not null...
			array_push($cat, "1");

			$query = 'SELECT DISTINCT(img.id), img.file, img.date_available, img.date_creation, img.tn_ext, img.name, 
					  img.comment, img.author, img.hit ,img.filesize, img.average_rate, img.has_high, img.path, 
					  img.level '
					.' FROM ' . IMAGES_TABLE.' AS img'
					.' INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON img.id = ic.image_id'
					.' WHERE
						img.date_available >= SUBDATE(
						CURRENT_DATE,INTERVAL '.$user['recent_period'].' DAY) '
						.$forbidden
						.' '.$conf['order_by'].';';
		}
		// Plus vues
		elseif ($page['section'] == 'recent_cats')
		{
			// $cat need to bo not null...
			array_push($cat, "1");

			$query = 'SELECT DISTINCT(img.id), img.file, img.date_available, img.date_creation, img.tn_ext, img.name, 
					  img.comment, img.author, img.hit ,img.filesize, img.average_rate, img.has_high, img.path, 
					  img.level, ic.category_id, cat.name AS catname, cat.comment AS catcomment, cat.rank, cat.status, 
					  cat.visible, cat.uppercats, cat.permalink '
					.' FROM ' . IMAGES_TABLE.' AS img'
					.' INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON img.id = ic.image_id'
					.' INNER JOIN '.CATEGORIES_TABLE.' AS cat ON ic.category_id = cat.id'			
					.' INNER JOIN '.USER_CACHE_CATEGORIES_TABLE.' ON cat.id = cat_id and user_id = '.$user['id']
					.' WHERE date_last >= SUBDATE(
						CURRENT_DATE,INTERVAL '.$user['recent_period'].' DAY
						)
						'.get_sql_condition_FandF
							(
								array('visible_categories' => 'id',),
							'AND'
							).'
						;';
		}
		
		// Plus vues
		elseif ($page['section'] == 'most_visited')
		{
			// $cat need to bo not null...
			array_push($cat, "1");
			$query = 'SELECT DISTINCT(img.id), img.file, img.date_available, img.date_creation, img.tn_ext, img.name, 
					  img.comment, img.author, img.hit ,img.filesize, img.average_rate, img.has_high, img.path, 
					  img.level, ic.category_id, cat.name AS catname, cat.comment AS catcomment, cat.rank, cat.status, 
					  cat.visible, cat.uppercats, cat.permalink '
					.' FROM ' . IMAGES_TABLE.' AS img'
					.' INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON img.id = ic.image_id'
					.' INNER JOIN '.CATEGORIES_TABLE.' AS cat ON ic.category_id = cat.id'			
					.' WHERE img.hit > 0 '
				    .$forbidden
					.' ORDER BY hit DESC, file ASC'
					.' LIMIT 0, '.$conf['top_number'].';';
		
		}
		// mieux notees	
		elseif ($page['section'] == 'best_rated')
		{
			// $cat need to bo not null...
			array_push($cat, "1");

			$query = 'SELECT DISTINCT(img.id), img.file, img.date_available, img.date_creation, img.tn_ext, img.name, 
					  img.comment, img.author, img.hit ,img.filesize, img.average_rate, img.has_high, img.path, 
					  img.level '
					.' FROM ' . IMAGES_TABLE.' AS img'
					.' INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON img.id = ic.image_id'
					.' WHERE img.average_rate IS NOT NULL '
					.$forbidden
					.' ORDER BY average_rate DESC, id ASC'
					.' LIMIT 0, '.$conf['top_number'].';';
		}
		elseif ($page['section'] == 'favorites')
		{
			check_user_favorites();
			// $cat need to bo not null...
			array_push($cat, "1");

			$query = 'SELECT img.id, img.file, img.date_available, img.date_creation, img.tn_ext, img.name, 
					  img.comment, img.author, img.hit ,img.filesize, img.average_rate, img.has_high, img.path, 
					  img.level '
					.' FROM '.FAVORITES_TABLE.' AS fav '
					.' INNER JOIN '.IMAGES_TABLE.' AS img ON fav.image_id = img.id'
					.' INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON img.id = ic.image_id'
					.' WHERE user_id = '.$user['id']
					.' '.get_sql_condition_FandF
						(
							array('visible_images' => 'id'),
							'AND'
						)
					.' '.$conf['order_by'].';';
		}
	
		elseif (($page['section']) == 'categories')
		{
			// Accueil
			if(empty($page['category'])) 
			{
				// Page accueil
				// Vrification d'activation du plugin (page administration)
				// ou flux pour piclenswall et configuration specifique
				if ($obj->my_config['piclens_gallerie_active'] || $piclenswallfeed)
				{
					// Categories de premier niveau 
					$query = 'SELECT id,name,permalink FROM ' . CATEGORIES_TABLE
					.' WHERE id_uppercat is NULL';
					
					$result = pwg_query($query);

					while ($row = mysql_fetch_assoc($result))
					{
						if (!(in_array($row['id'], explode(',', $user['forbidden_categories']))))
						{
									array_push($cat, $row['id']);
								
						}
					}
					// Type = avec recursiite 
					// Si parametrage specifique pour le mur 3D,  recursivite sur les categories 
					if (($piclenswallfeed) || (( $obj->my_config['piclens_gallerie_type'])-1))
					{
						// recuperation des sous-categories (tous niveaux) de la categorie en cours.
						$subcat= get_subcat_ids($cat);
			
						// Verification droits des sous-categories
						foreach($subcat as $sscat)
						{
							if (!(in_array($sscat, explode(',', $user['forbidden_categories']))))
									array_push($cat, $sscat);
						}
					}

					// selection uniquement des categories a afficher (si flux pour le mur ET parametre mur = specifique)
					if ($piclenswallfeed)
					{
						foreach($cat as $i => $wcat)
						{
							if (!in_array($wcat, $piclenswall_cat))
								unset($cat[$i]);
						}
					}

					$query = 'SELECT DISTINCT(img.id), img.file, img.date_available, img.date_creation, img.tn_ext, img.name, 
							  img.comment, img.author, img.hit ,img.filesize, img.average_rate, img.has_high, img.path, 
							  img.level, ic.category_id, cat.name AS catname, cat.comment AS catcomment, cat.rank, cat.status, 
							  cat.visible, cat.uppercats, cat.permalink '
					.' FROM ' . IMAGES_TABLE.' AS img'
					.' INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON img.id = ic.image_id'
					.' INNER JOIN '.CATEGORIES_TABLE.' AS cat ON ic.category_id = cat.id'
					.' WHERE ic.category_id IN ('.implode(',', $cat).')'
					.(sizeof($obj->my_config['included_file_types']) ? ' AND (img.tn_ext IN ('.implode(',', $type_ext).')' : '')
					.($tn_ext_is_null ? ' OR img.tn_ext IS NULL)' : (sizeof($obj->my_config['included_file_types']) ? ')' : ''))
					// Verif droits (niveaux) de l'utilisateur sur les images 
					.' AND img.level <='.$user['level'].' '
					// Choix du critere de tri d'affichage
					.$order_list[ $obj->my_config['piclens_order'] ]
					.$order_sort[ $obj->my_config['piclens_sort'] ];
					
					
				}
			}
			
			// Page category
			elseif (isset($page['category']))
			{
				check_restrictions($page['category']['id']);
		
				// Flux pour le mur 3D et mur en mode "specifique"
				if ($piclenswallfeed)
				{
					$selectionID = $page['category']['id'];
					//  categorie parametre pour etre affichee dans le mur
					if (in_array($selectionID, $piclenswall_cat))
						array_push($cat, $selectionID);

					// recuperation des sous-categories (tous niveaux) de la categorie en cours.
					$subcat= get_subcat_ids(array($selectionID));

					// Verification ajout des sous-categories qui peuvent tre affichees (parametrees dans mur 3D) et des drois des sous categories 
					foreach($subcat as $sscat)
					{
						if ((in_array($sscat, $piclenswall_cat)) && (!(in_array($sscat, explode(',', $user['forbidden_categories'])))))
							array_push($cat, $sscat);
					}

				}
				// Piclens (et mur 3D avec meme parametrage que piclens) : paramtrage "commun"
				else
				{		
					//  recherche de toutes les photos de la categorie (incluant les photos des sous-categories si necessaire)
					$selectionID = $page['category']['id'];

					array_push($cat, $selectionID);

					// Si recursivite activee 
					if ($obj->my_config['piclens_recursive'])
					{
						// recuperation des sous-categories (tous niveaux) de la categorie en cours.
						$subcat= get_subcat_ids(array($selectionID));

						// Verification droits des sous-categories
						foreach($subcat as $sscat)
				 		{
							if (!(in_array($sscat, explode(',', $user['forbidden_categories']))))
								array_push($cat, $sscat);
						}
					
					}
				}
					
				$query = 'SELECT DISTINCT(img.id), img.file, img.date_available, img.date_creation, img.tn_ext, img.name, 
						  img.comment, img.author, img.hit ,img.filesize, img.average_rate, img.has_high, img.path, 
						  img.level, ic.category_id, cat.name AS catname, cat.comment AS catcomment, cat.rank, cat.status, 
						  cat.visible, cat.uppercats, cat.permalink '
				.' FROM ' . IMAGES_TABLE.' AS img'
				.' INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON img.id = ic.image_id'
				.' INNER JOIN '.CATEGORIES_TABLE.' AS cat ON ic.category_id = cat.id'
				.' WHERE ic.category_id IN ('.implode(',', $cat).')'
				.(sizeof($obj->my_config['included_file_types']) ? ' AND (img.tn_ext IN ('.implode(',', $type_ext).')' : '')
				.($tn_ext_is_null ? ' OR img.tn_ext IS NULL)' : (sizeof($obj->my_config['included_file_types']) ? ')' : ''))
				// Verif droits (niveaux) de l'utilisateur sur les images 
				.' AND img.level <='.$user['level'].' '
				// Choix du critere de tri d'affichage
				.$order_list[ $obj->my_config['piclens_order_cat'] ]
				.$order_sort[ $obj->my_config['piclens_sort_cat'] ];

				}
		}
			
		if ($debug)	echo $query;
		
			// Si au moins une image rcupre (une catgorie ou une image prsente)
		if (count($cat)!=0)
		{
			$result = pwg_query($query);
			while ($row = mysql_fetch_assoc($result))
			{
				// Plugin Extended Description present et active
				// suppression des categories et images pour lesquelles un <!--hidden--> est present 
				if (!$plugins_ExtendedDesc
					OR ($plugins_ExtendedDesc 
						&& !(substr_count($row['name'],  $piclens_extdesc_hidden)) 
						&& ((isset($row['catname']) ? !(substr_count($row['catname'],  $piclens_extdesc_hidden)) : true))
						))
					array_push($pictures, $row);
			}
		}
		// Fin requetes recherches photos
		
		// Creation du fichier xml (flux rss)
		// It's a rss file
		header("Content-Type: application/xml; charset=UTF-8");
		echo '<?xml version="1.0" encoding="utf-8" standalone="yes"?>';
		echo "\n";
		echo '<rss version="2.0" '."\n"
			 .'xmlns:media="http://search.yahoo.com/mrss/" '."\n"
			 .'xmlns:atom="http://www.w3.org/2005/Atom">';
		echo "\n";
		echo '<channel>';
		echo "\n";

		//	<!--	<title>test Page</title> -->
		echo '<link>'.get_root_url().'</link>';
		echo "\n";
		echo '<description>Flux RSS pour cooliris</description>';
		echo "\n";
		echo '<language>fr</language>';
		echo "\n";

		// Version du plugin Piclens
		$db_plugins = get_db_plugins('', 'piclens'); 
		if (!empty($db_plugins)) 
			$piclens_version = $db_plugins[0]['version']; 
		else
			$piclens_version = 'N/A'; 

		echo '<generator>Piwigo Cooliris Plugin v.'.$piclens_version.'</generator>';
		echo "\n";

		// Icone de la gallerie dans le flux RSS
//		echo '<logo url="'.get_root_url().'template-common/favicon.ico"></logo>';
		echo "\n";
		echo '<atom:icon>'.get_root_url().'template-common/favicon.ico</atom:icon>';
		echo "\n";
//   <atom:link href="http://mywebsite.com/photos.rss" rel="self" type="application/rss+xml" />

		// Pour chacune des images, preparation du flux xml
		foreach ($pictures as $row)
		{
			// Mode de l'image parametre
			$piclens_normal = $obj->my_config['piclens_normal'];

			// si parametrage high et high absente ou utilisateur non habilite, affichage version normale
			if (($piclens_normal == 3) && (!($row['has_high']) || !$user['enabled_high']))
				$piclens_normal = 2; // Normal uniquement pour l'image en cours

			// Get thumbnail url
			if ($plugins_SecureImage)	// SecureImage installe et actif
			{
				$link_url = get_root_url().'plugins/secureImages/getFile.php?image_id='.$row['id'];

				$thumbnail_url = get_root_url().'plugins/secureImages/getFile.php?image_id='.$row['id']
				.$thumb_secure[$obj->my_config['piclens_thumb'] ];
				$content_url = get_root_url().'plugins/secureImages/getFile.php?image_id='.$row['id']
				.$normal_secure[$piclens_normal ];
			}
			else	// SecureImage non installe ou non actif
			{
				$link_url = get_root_url().$row['path'];
				
				if ( ($obj->my_config['piclens_thumb']) == 2) 	// Normal
					$thumbnail_url = (url_is_remote($row['path']) ? $row['path']: get_root_url().$row['path']);
				else
				{
					if ($plugins_SecureImage_only)	// Plugin secureimage active mais configuration compatibilite piclens-secureimage desactivee
					{
						$path=get_thumbnail_location($row);
						  if ( !url_is_remote($path) )
							$thumbnail_url = embellish_url(get_root_url().$path);
					}
					else	// Plugin secureimage desactive
						$thumbnail_url = get_thumbnail_url($row);
				}	

				switch ($piclens_normal)
				{
					case 1 : // miniature
						if ($plugins_SecureImage_only)	// Plugin secureimage active mais configuration compatibilite piclens-secureimage desactivee
						{
							$path=get_thumbnail_location($row);
							  if ( !url_is_remote($path) )
								$content_url = embellish_url(get_root_url().$path);
						}
						else	// Plugin secureimage desactive
							$content_url = get_thumbnail_url($row);
						break;
					case 2 : // normal
						$content_url = (url_is_remote($row['path']) ? $row['path']: get_root_url().$row['path']);
						break;
					case 3 : 
						 $content_url = get_root_url(). dirname($row['path']).'/pwg_high/'.basename($row['path']);
						 break;
					default : // normal
						$content_url = (url_is_remote($row['path']) ? $row['path']: get_root_url().$row['path']);
						break;
				}
			}
			
			// link on picture.php page
			$url = duplicate_picture_url(
				array(
					'image_id' => $row['id'],
					'image_file' => $row['file']
				),
				array('start')
			);
			
			// Show rss item for a picture
			echo "<item>\n";
			
			// Recuperation informations de la categorie (Present maintenant dans row['catname'])
			//$catinfo = get_cat_info($row['category_id']);
			// Titre de l'image dans Piclens 			
			switch($obj->my_config['piclens_name_image'])
			{
				case 2 :
						// format nom fichier
					echo "<title><![CDATA["
						  .(($obj->my_config['piclens_cat_view'] && isset ($row['catname'])) ? $row['catname']." - " : "") 
						  . $row['file'] . "]]></title>\n";
					break;
				case 3 :
					// format nom de la photo
					if (isset($row['name']))
						echo "<title><![CDATA["
						  .(($obj->my_config['piclens_cat_view'] && isset ($row['catname'])) ? $row['catname']." - " : "") 
						.$row['name']."]]></title>\n";
					else 
						echo "<title><![CDATA[" 
						  .(($obj->my_config['piclens_cat_view'] && isset ($row['catname'])) ? $row['catname']." - " : "") 
						. $row['file'] . "]]></title>\n";
					break;
				default :
						// format nom fichier : taille
					echo "<title><![CDATA[" 
						  .(($obj->my_config['piclens_cat_view'] && isset ($row['catname'])) ? $row['catname']." - " : "") 
					. get_thumbnail_title($row) . "]]></title>\n";
					break;
			}

			// Description (nom de vignette) present
			switch($obj->my_config['piclens_name_desc'])
			{
				case 2 :
					if (isset($row['name']))
					echo '<media:description type="html"><![CDATA['.$row['name'].']]> </media:description>';
					break;
				case 3 : 
					if (isset($row['comment']))
					{
						if ($plugins_ExtendedDesc)	// Extended description compatibility
						{
							$desc=trigger_event('render_element_description',$row['comment']);
							echo '<media:description type="html"><![CDATA['.$desc.']]> </media:description>';
						}
						else
							echo '<media:description type="html"><![CDATA['.$row['comment'].']]> </media:description>';					

					}
					break;
				default :
					break;
			}
			echo "\n";
	 
			// link
			echo "<link>" . $url . "</link>\n";

//			echo "<guid>" . $row['id'] . "\</guid>\n";				
			echo "<guid isPermaLink=\"false\">\"" . $row['id'] . "\"</guid>\n";
			
			echo "<media:thumbnail url=\"" . $thumbnail_url . "\" />\n";

			$extension = explode(".", $row['file']); 
			$extension = $extension[sizeof($extension)-1];

			// Fichiers video  (Charlies content)
			if ((in_array($extension, $video_ext_piclens))) 
			{
				if ($obj->my_config['piclens_video'])	// activation des videos
				{
					switch ($extension)
					{
						case "flv":
							echo "<media:content type=\"video/x-flv\" url=\"".$content_url."\"/>\n";
							break;
					}
				}
				else
				{
					echo "<media:content url=\"" . $thumbnail_url . "\" />\n";
				}
			}
			// Fichiers video  (PY Gvideo)
			elseif ((in_array($extension, $py_addext))) 
			{
				if ($obj->my_config['piclens_video'])	// activation des videos
				{
					// Si impossibilite de lire le fichier!
					if( false == ($idvideo = file_get_contents(PHPWG_ROOT_PATH.$row['path'])))
					{
						echo "<media:content url=\"" . $thumbnail_url . "\" />\n";					
					}
					else
					{
						$sp = explode("/", $idvideo);
						switch ($extension)
						{
							case "dm" :
								echo "<enclosure url=\"http://www.dailymotion.com/swf/".$sp[0]."\" type=\"application/x-shockwave-flash\" />\n";
								break;
							case "ytube":
								echo "<enclosure url=\"http://youtube.com/v/".$sp[0].".swf\" type=\"application/x-shockwave-flash\" />\n";
								break;
							case "wideo":
								echo "<enclosure url=\"http://www.kewego.com/swf/p3/epix.swf?language_code=fr&amp;playerKey=0df9b773a15b&amp;skinKey=7109c4112f57&amp;sig=".$sp[0]."\" type=\"application/x-shockwave-flash\" />\n";
								break;
							case "gvideo":
								echo "<enclosure url=\"http://video.google.com/googleplayer.swf?docid=".$sp[0]."\" type=\"application/x-shockwave-flash\" />\n";
								break;
							case "vimeo":
								echo "<enclosure url=\"http://vimeo.com/moogaloop.swf?clip_id=".$sp[0]."\" type=\"application/x-shockwave-flash\" />\n";
								break;
						}
					}
				}
				else
				{
					echo "<media:content url=\"" . $thumbnail_url . "\" />\n";
				}
			}
			// Images (standard)
			else
				echo "<media:content url=\"" . $content_url . "\" />\n";

			echo "</item>\n";
			echo "\n";
		}
		echo "</channel>\n";
		echo "</rss>";
	}
}

?>